new_theory `U3_COMP` ;;
loadf `UU_UNITY` ;;
loadf `OLD_RES` ;;
loadf `DerLem` ;;
ADD_TRANS ("==>", 
    prove("!p q r. (p==>q) /\ (q==>r) ==> (p==>r)",TAUT_TAC)) ;;
ADD_TRANS ("<==", 
    prove("!p q r. (p<==q) /\ (q<==r) ==> (p<==r)",
    REWRITE_TAC[definition `predicate` `IMPBY`] THEN TAUT_TAC)) ;;


Set_Assumptions [(`asm1`,"Inv (Pr:^Uprog) J") ] ;;

BD "==>" "UNL (Pr:^Uprog) H p q" ;;

DERIVE ("=:bool->bool->bool",
        "UNLESS Pr (p AND H) (q AND H) /\ Inv (Pr:^Uprog) H",
        `Definition of UNL`,
        REWRITE_TAC [UNL]) ;;

DERIVE ("==>",
        "UNLESS Pr ((p AND H) AND J) (J AND (q AND H))  /\  
         Inv (Pr:^Uprog) (H AND J)",
        `J is Invariant; conjunction with stable predicate`,
        REPEAT STRIP_TAC
        THENL 
        [ SUBGOAL_THEN "UNLESS (Pr:^Uprog) J FF"
          (\thm. ASSUME_TAC thm)
          THENL [ XRULE_ASSUM_TAC (REWRITE_RULE [Inv])
                  THEN ASM_REWRITE_TAC[] ; ALL_TAC ] 
          THEN OLD_IMP_RES_TAC UNLESS_CONJ
          THEN XRULE_ASSUM_TAC 
               (REWRITE_RULE [ONCE_REWRITE_RULE [pAND_SYM] pAND_ZERO])
          THEN XRULE_ASSUM_TAC 
               (REWRITE_RULE [pOR_UNIT; ONCE_REWRITE_RULE [pOR_SYM] pOR_UNIT])
          THEN ASM_REWRITE_TAC[] ;
          IMP_RES_TAC Inv_CONJ ]) ;;

DERIVE ("=:bool->bool->bool",
        "UNL (Pr:^Uprog) (H AND J) p q",
        `Predicate Calculus and Definition UNL`,
         REWRITE_TAC [UNL]
         THEN SUBGOAL_THEN "(p AND H) AND J = (p:^Pred) AND (H AND J)"
         (\thm. REWRITE_TAC [thm])
         THENL [ pred_CYAN_TAC ; ALL_TAC ]
         THEN SUBGOAL_THEN "J AND (q AND H) = (q:^Pred) AND (H AND J)"
         (\thm. REWRITE_TAC [thm])
         THEN pred_CYAN_TAC) ;; 

let UNL_Inv_STR = prove_thm
  (`UNL_Inv_STR`,
   "!Pr:^Uprog. ! p q H J.
       (Inv Pr J) /\ (UNL Pr H p q)   ==>  (UNL Pr (H AND J) p q)",
    REPEAT STRIP_TAC 
    THEN IMP_RES_TAC (GEN_ALL (DISCH_ALL (ETD())))) ;;
Set_Assumptions
   [ (`asm1`,"Inv (Pr:^Uprog) J") ] ;;

BD "==>" "ENS (Pr:^Uprog) H p q" ;;

DERIVE ("=:bool->bool->bool",
        "ENSURES Pr (p AND H) (q AND H) /\ Inv (Pr:^Uprog) H",
        `Definition of ENS`,
        REWRITE_TAC [ENS]) ;;

DERIVE ("==>",
        "ENSURES Pr (J AND (p AND H)) (J AND (q AND H))  /\  
         Inv (Pr:^Uprog) (H AND J)",
        `J is Invariant`,
        REPEAT STRIP_TAC
        THENL 
        [ SUBGOAL_THEN "UNLESS (Pr:^Uprog) J FF"
          (\thm. ASSUME_TAC thm)
          THENL [ XRULE_ASSUM_TAC (REWRITE_RULE [Inv])
                  THEN ASM_REWRITE_TAC[] ; ALL_TAC ] 
          THEN OLD_IMP_RES_TAC ENSURES_PSP
          THEN XRULE_ASSUM_TAC 
               (REWRITE_RULE [pAND_ZERO; ONCE_REWRITE_RULE [pAND_SYM] pAND_ZERO])
          THEN XRULE_ASSUM_TAC 
               (REWRITE_RULE [ONCE_REWRITE_RULE [pOR_SYM] pOR_UNIT])
          THEN ASM_REWRITE_TAC[] ;
          IMP_RES_TAC Inv_CONJ ]) ;;

DERIVE ("=:bool->bool->bool",
        "ENS (Pr:^Uprog) (H AND J) p q",
        `Predicate Calculus and Definition ENS`,
         REWRITE_TAC [ENS]
         THEN SUBGOAL_THEN "J AND (p AND H) = (p:^Pred) AND (H AND J)"
         (\thm. REWRITE_TAC [thm])
         THENL [ pred_CYAN_TAC ; ALL_TAC ]
         THEN SUBGOAL_THEN "J AND (q AND H) = (q:^Pred) AND (H AND J)"
         (\thm. REWRITE_TAC [thm])
         THEN pred_CYAN_TAC) ;;

let ENS_Inv_STR = prove_thm
  (`ENS_Inv_STR`,
   "!(Pr:^Uprog) p q H J.
       (Inv Pr J) /\ (ENS Pr H p q)   ==>  (ENS Pr (H AND J) p q)",
    RESTRICT_DEF_TAC THEN REPEAT STRIP_TAC 
    THEN IMP_RES_TAC (GEN_ALL (DISCH_ALL (ETD())))) ;;    
Set_Assumptions
   [ (`asm1`,"Inv (Pr:^Uprog) J") ;
     (`asm2`,"LocPred (Pr:^Uprog) J") ] ;;

BD "==>" "LTO (Pr:^Uprog) H p q" ;;

DERIVE ("=:bool->bool->bool",
        "LEADSTO Pr (p AND H) (q AND H) /\ Inv (Pr:^Uprog) H",
        `Definition of LTO`,
        REWRITE_TAC [LTO]) ;;

DERIVE ("==>",
        "LEADSTO Pr ((p AND H) AND J) ((q AND H) AND J)  /\  
         Inv (Pr:^Uprog) (H AND J)",
        `J is Invariant`,
        REPEAT STRIP_TAC
        THENL 
        [ SUBGOAL_THEN "UNLESS (Pr:^Uprog) J FF"
          (\thm. ASSUME_TAC thm)
          THENL [ XRULE_ASSUM_TAC (REWRITE_RULE [Inv])
                  THEN ASM_REWRITE_TAC[] ; ALL_TAC ] 
          THEN ASSUME_TAC (SPEC "Pr:^Uprog" LocPred_FF)
          THEN IMP_RES_TAC (RESTRICT_DEF_RULE LEADSTO_PSP)
          THEN XRULE_ASSUM_TAC 
               (REWRITE_RULE [ONCE_REWRITE_RULE [pOR_SYM] pOR_UNIT])
          THEN ASM_REWRITE_TAC[] ;
          IMP_RES_TAC Inv_CONJ ]) ;;

DERIVE ("=:bool->bool->bool",
        "LTO (Pr:^Uprog) (H AND J) p q",
        `Predicate Calculus and Definition ENS`,
         REWRITE_TAC [LTO]
         THEN SUBGOAL_THEN "(p AND H) AND J = (p:^Pred) AND (H AND J)"
         (\thm. REWRITE_TAC [thm])
         THENL [ pred_CYAN_TAC ; ALL_TAC ]
         THEN SUBGOAL_THEN "(q AND H) AND J = (q:^Pred) AND (H AND J)"
         (\thm. REWRITE_TAC [thm])
         THEN pred_CYAN_TAC) ;;

let LTO_Inv_STR = prove_thm
  (`LTO_Inv_STR`,
   "!(Pr:^Uprog) p q H. !J::LocPred Pr.
       (Inv Pr J) /\ (LTO Pr H p q)   ==>  (LTO Pr (H AND J) p q)",
    RESTRICT_DEF_TAC THEN REPEAT STRIP_TAC 
    THEN IMP_RES_TAC (GEN_ALL (DISCH_ALL (ETD())))) ;;    

let UNL_PAR = prove_thm (`UNL_PAR`,
   "! p q J Pr (Qr:^Uprog).
    (UNL Pr J p q) /\ (UNL Qr J p q) ==> (UNL (Pr PAR Qr) J p q)",
    REWRITE_TAC [UNL] THEN REPEAT STRIP_TAC
    THENL [ IMP_RES_TAC UNLESS_PAR ;
            IMP_RES_TAC Inv_PAR ]) ;;

let ENS_PAR = prove_thm (`ENS_PAR`,
   "!(Pr:^Uprog)::UNITY. !p q J Qr.
    (UNL Pr J p q) /\ (ENS Qr J p q) ==> (ENS (Pr PAR Qr) J p q)",
    REWRITE_TAC [UNL;ENS] 
    THEN RESTRICT_DEF_TAC THEN REPEAT STRIP_TAC
    THENL 
    [ IMP_RES_TAC (RESTRICT_SHIFT ENSURES_PAR) ;
      IMP_RES_TAC Inv_PAR ]) ;;

let UNLESS_CONJ_lem = prove
   ("UNLESS (Pr:^Uprog) (a AND p) (NOT q) /\
     UNLESS Pr (b AND q) c 
     ==> UNLESS Pr (a AND p AND b AND q) c",
     REPEAT STRIP_TAC
     THEN OLD_IMP_RES_TAC UNLESS_CONJ
     THEN REWRITE_TAC [prove 
          ("((a:^Pred) AND (p AND (b AND q))) = ((a AND p) AND (b AND q))",
          pred_CYAN_TAC)] 
     THEN ASSUME_TAC (prove
          ("|== (((((a AND p) AND c) OR ((b AND q) AND (NOT q))) OR
                ((NOT q) AND c)) IMP (c:^Pred))", pred_JADE_TAC 5))
     THEN IMP_RES_TAC UNLESS_CONSQ_WEAK) ;;

let UNLESS_DISJ_lem = prove
   ("(!C. UNLESS (Pr:^Uprog) (p AND (UP V $= C)) q)
     ==> UNLESS Pr p q",
     REPEAT STRIP_TAC    
     THEN IMP_RES_TAC
          ((BETA_RULE o RESTRICT_DEF_RULE o
           ISPECL ["Pr:^Uprog"; "\C:^State. T"; 
                    "\C:^State. (p:^Pred) AND (UP V $= C)";
                    "\C:^State. (q:^Pred)"]) UNLESS_GEN_DISJ)
     THEN UNDISCH_ALL_TAC
     THEN REWRITE_TAC [UP_DEF] THEN pred_JADE_TAC 0
     THEN SUBGOAL_THEN 
          "!s. (?i:^State. p s /\ (!x. V x ==> (s x = i x))) = p s"
          (\thm. XRULE_ASSUM_TAC (REWRITE_RULE [thm])) 
     THENL [ STRIP_TAC THEN EQ_TAC THEN REPEAT STRIP_TAC
             THEN EXISTS_TAC "s:^State"
             THEN ASM_REWRITE_TAC[] ; ALL_TAC ]
     THEN ASSUME_TAC (prove(
     "|== ((\s. (!i. ~(p s /\ (!x. V x ==> (s x = i x))) \/ q s) /\ q s)
          IMP (\s:^State. q s))", pred_JADE_TAC 3))
     THEN IMP_RES_TAC UNLESS_CONSQ_WEAK
     THEN XRULE_ASSUM_TAC (REWRITE_RULE [ETA_CONV "\x. (f:*->**) x"])
     THEN ASM_REWRITE_TAC[]) ;;
let V = "DVa (Pr:^Uprog) Qr" ;;

Set_Assumptions
   [(`asm0`,"ENSURES (Pr:^Uprog) p q") ;
    (`asm1`,"UNITY (Qr:^Uprog)") ; 
    (`asm2`,"!C. UNLESS (Qr:^Uprog) (a AND (UP ^V $= C)) b") ] ;;

BD "==>" "LocPred (Pr:^Uprog) p" ;;

DERIVE("==>",
   "!C. UNLESS (Qr:^Uprog) (p AND (UP ^V $= C)) (NOT (UP ^V $= C))",
   `by LocPred_SAFE`,
    STRIP_TAC THEN IMP_RES_TAC LocPred_SAFE
    THEN ASM_REWRITE_TAC[]) ;;

DERIVE("==>",
    "!C. UNLESS (Qr:^Uprog) ((p AND (UP ^V $= C)) AND a) b",
    `Conjunction with asm2 then weakening the 2nd argument of the UNLESS`,
     REPEAT STRIP_TAC 
     THEN XRULE_ASSUM_TAC (SPEC "C:^State")
     THEN OLD_IMP_RES_TAC UNLESS_CONJ_lem
     THEN ASM_REWRITE_TAC
          [prove("((p AND X) AND a) = ((p:^Pred) AND (X AND (a AND X)))", 
          pred_CYAN_TAC)]) ;;
          
DERIVE("==>", "UNLESS (Qr:^Uprog) (p AND a) b",
     `by disjuctivity of UNLESS (use UNLESS_DISJ_lem)`,
      ONCE_REWRITE_TAC [prove
           ("(P AND Q) AND R = (P AND R) AND (Q:^Pred)", pred_CYAN_TAC)]
      THEN STRIP_TAC
      THEN IMP_RES_TAC UNLESS_DISJ_lem) ;;

DERIVE("==>", "UNLESS (Qr:^Uprog) (p AND a) (q OR (NOT a) OR b)",
       `UNLESS is monotonic at its 2nd argument`,
       STRIP_TAC
       THEN ASSUME_TAC (prove(
            "|== ((b:^Pred) IMP (q OR (NOT a) OR b))", pred_JADE_TAC 3))
       THEN IMP_RES_TAC UNLESS_CONSQ_WEAK) ;;


LEMMA (`lem10`, "UNLESS (Pr:^Uprog) a (NOT a)",
       `UNLESS is anti-reflexive`,
       REWRITE_TAC [UNLESS_ANTI_REFL]) ;;

LEMMA (`lem20`,
       "ENSURES (Pr:^Uprog) (p AND a) (q OR (NOT a))",
        `asm0, lem10 and PSP Rule`,
        ASSUME_TAC (RECALL `lem10`) 
        THEN OLD_IMP_RES_TAC ENSURES_PSP
        THEN ASSUME_TAC (prove
             ("|== ((((a AND q) OR (p AND (NOT a))) OR ((NOT a) AND q)) IMP
                    (q OR (NOT (a:^Pred))))", pred_JADE_TAC 3))
        THEN ONCE_REWRITE_TAC [pAND_SYM]
        THEN OLD_IMP_RES_TAC ENSURES_CONSQ_WEAK) ;;

LEMMA (`lem30`,
       "ENSURES (Pr:^Uprog) (p AND a) (q OR (NOT a) OR b)",
       `lem20, ENSURES is monotonic at 2nd argument`,
        ASSUME_TAC (prove(
        "|== ((q OR (NOT a)) IMP (q OR (NOT a) OR (b:^Pred)))",
         pred_JADE_TAC 3)) 
        THEN ASSUME_TAC (RECALL `lem20`)  
        THEN IMP_RES_TAC ENSURES_CONSQ_WEAK) ;;  

let ENSURES_SINGH = prove_thm (`ENSURES_SINGH`,
   "!(Pr:^Uprog) p q a b. !Qr::UNITY.
        LocPred Pr p /\ ENSURES Pr p q /\
        (!C. UNLESS Qr (a AND (UP(DVa Pr Qr)$= C)) b)
        ==>
        ENSURES (Pr PAR Qr) (p AND a) (q OR (NOT a) OR b)",
    RESTRICT_DEF_TAC 
    THEN REPEAT STRIP_TAC
    THEN IMP_RES_TAC (DISCH_ALL(ETD()))
    THEN IMP_RES_TAC (DISCH_ALL (RECALL `lem30`))
    THEN ONCE_REWRITE_TAC [PAR_SYM]
    THEN XRULE_ASSUM_TAC SPEC_ALL
    THEN IMP_RES_TAC (RESTRICT_SHIFT ENSURES_PAR)) ;;
Set_Assumptions 
    [(`asm0`,"LEADSTO (Pr:^Uprog) (p AND a) (r OR ((NOT a) OR b))");
     (`asm1`,"LEADSTO (Pr:^Uprog) (r AND a) (q OR ((NOT a) OR b))");
     (`asm3`,"LocPred (Pr:^Uprog) r") ;
     (`asm4`,"LocPred (Pr:^Uprog) a") ;
     (`asm5`,"LocPred (Pr:^Uprog) b") ] ;;

LEMMA(`lem10`,
      "LEADSTO (Pr:^Uprog) 
               (p AND a) 
               (((NOT a) OR b) OR (r AND a AND (NOT b)))",
   `asm0, predicate calculus`,
    REWRITE_TAC [prove(
       "(((NOT a) OR b) OR (r AND a AND (NOT b))) = 
        ((r:^Pred) OR ((NOT a) OR b))", pred_CYAN_TAC) ;
        RECALL `asm0`] ) ;;

LEMMA(`lem20`,
      "LEADSTO  (Pr:^Uprog) (r AND a AND (NOT b))
                            (q OR ((NOT a) OR b))",
      `asm1, LEADSTO is left monotonic`,
       MATCH_MP_TAC (QUAFF_RULE 3 LEADSTO_ANTE_STRONG)
       THEN EXISTS_TAC "(r:^Pred) AND a"
       THEN ASM_REWRITE_TAC[]
       THEN CONJ_TAC 
       THENL [ LocPred_TAC 3; pred_JADE_TAC 3]) ;;

LEMMA(`lem30`,
      "LEADSTO (Pr:^Uprog)  (p AND a) (q OR ((NOT a) OR b))",
      `lem10, lem20, Cancelation Rule`,
       SUBST1_TAC (prove(
            "(q OR ((NOT a) OR (b:^Pred))) =
             (((NOT a) OR b) OR (q OR ((NOT a) OR b)))",
             pred_CYAN_TAC))
       THEN MATCH_MP_TAC (QUAFF_RULE 3 LEADSTO_CANCEL)
       THEN EXISTS_TAC "(r:^Pred) AND a AND (NOT b)"
       THEN REWRITE_TAC [RECALL `lem10`; RECALL `lem20`]
       THEN LocPred_TAC 3) ;;

let SINGH__lemma1 = GEN_RECALL `lem30` ;;
let LEADSTO_SINGH_ind = prove
   ("UNITY Qr /\
     LocPred (Pr PAR Qr) a /\ LocPred (Pr PAR Qr) b /\
     (!C. UNLESS Qr (a AND (UP(DVa Pr Qr)$= C)) b)
     ==> (LEADSTO (Pr:^Uprog) p q ==>
         (\x y. LEADSTO (Pr PAR Qr) (x AND a) (y OR (NOT a) OR b)) p q)",
     STRIP_TAC
     THEN LEADSTO_INDUCT3_TAC
     THENL 
     [ %--- ENSURES case ---%
       MATCH_MP_TAC (QUAFF_RULE 3 LEADSTO_ENS_LIFT)
       THEN REPEAT CONJ_TAC
       THENL 
       [ OLD_IMP_RES_TAC (SPEC_ALL LocPred_PAR)
         THEN LocPred_TAC 3 ;
         OLD_IMP_RES_TAC (SPEC_ALL LocPred_PAR)
         THEN LocPred_TAC 3 ;
         IMP_RES_TAC (RESTRICT_SHIFT ENSURES_SINGH) ] ;
       %--- transitivity ---%
       MATCH_MP_TAC (QUAFF_RULE 5 SINGH__lemma1)
       THEN EXISTS_TAC "y:^Pred"
       THEN ASM_REWRITE_TAC[]
       THEN MATCH_MP_TAC LocPred_PAR
       THEN IMP_RES_TAC LEADSTO_LOC ;
       %--- disjunctivity ---%
       REWRITE_TAC [BETA_RULE 
               (ISPECL ["W:^Pred->bool"; "\p:^Pred. p"]
                qAND_RIGHT_DISTR_OR)]
       THEN MATCH_MP_TAC (BETA_RULE 
               (ISPECL ["Pr:^Uprog"; "W:^Pred->bool"; 
                        "\p:^Pred. p AND a"]
                LEADSTO_DISJ_LEFT))
       THEN UNDISCH_ALL_TAC
       THEN RESTRICT_DEF_TAC THEN REWRITE_TAC [Non_FF_lemma]
       THEN REPEAT STRIP_TAC 
       THENL [ EXISTS_TAC "x:^Pred" THEN ASM_REWRITE_TAC[] ;
               RES_TAC]]) ;;

let SINGH_thm = prove_thm (`SINGH_thm`,
    "!Pr p q a b. !(Qr:^Uprog)::UNITY. 
         LocPred(Pr PAR Qr)a /\
         LocPred(Pr PAR Qr)b /\
         LEADSTO Pr p q /\ 
         (!C. UNLESS Qr (a AND (UP(DVa Pr Qr)$= C)) b) 
         ==>
         LEADSTO  (Pr PAR Qr) (p AND a) (q OR ((NOT a) OR b))",
    RESTRICT_DEF_TAC
    THEN REPEAT STRIP_TAC
    THEN IMP_RES_TAC (BETA_RULE LEADSTO_SINGH_ind)) ;;
let lemma = 
    REWRITE_RULE [pAND_UNIT; NOT_TT; 
                  ONCE_REWRITE_RULE [pAND_SYM] pAND_UNIT ;
                  pOR_UNIT] 
    (SPECL ["Pr:^Uprog"; "p:^Pred"; "q:^Pred"; "TT:^Pred"] SINGH_thm) ;;


let SINGH_SIMPLE_thm = prove_thm 
  (`SINGH_SIMPLE_thm`,
    "!Pr p q b. !(Qr:^Uprog)::UNITY. 
         LocPred (Pr PAR Qr) b /\
         LEADSTO Pr p q /\ 
         (!C. UNLESS Qr (UP(DVa Pr Qr)$= C) b) 
         ==>
         LEADSTO (Pr PAR Qr) p (q OR b)",
    RESTRICT_DEF_TAC 
    THEN REPEAT STRIP_TAC
    THEN MATCH_MP_TAC (QUAFF_RULE 3 lemma)
    THEN ASM_REWRITE_TAC[]
    THEN LocPred_TAC 2) ;;

close_theory() ;;
