new_theory `Set_BM1` ;;

let ASet = ":*A->bool" ;;
let BSet = ":*B->bool" ;;

new_constant (`Unit`,ASet) ;;
new_constant (`Haplo`,":*A->^ASet") ;;
new_infix (`Cat`, ":^ASet -> ^ASet -> ^ASet") ;;
new_constant (`Map`,": (*A->*B) -> ^ASet -> ^BSet") ;;
new_constant (`Red`, ": *A -> (*A -> *A -> *A) -> ^ASet -> *A") ;;

%----------------- The Laws of Bird-Meertens Formalism -----------------------------%


let LUNIT_DEF = new_definition (`LUNIT`,
    "LUNIT op (e:*A) = !x:*A. op e x = x") ;;     

let RUNIT_DEF = new_definition (`RUNIT`,
    "RUNIT op (e:*A) = !x:*A. op x e = x") ;;  

let LUnit_Cat = "!x:^ASet. Unit Cat x = x" ;;

let RUnit_Cat = "!x:^ASet. x Cat Unit = x" ;;

let Map_I = "Map (I:*A->*A) = I" ;;

let Map_o = "!(f:*B->*C) (g:*A->*B). Map (f o g) = (Map f) o (Map g)" ;;

let Map_Unit = "!f:*A->*B. (Map f Unit) = Unit" ;;

let Map_Haplo = "!(f:*A -> *B) x. Map f (Haplo x) = Haplo (f x)" ;;

let Map_Cat = "!x y (f:*A -> *B). Map f (x Cat y) = (Map f x) Cat (Map f y)" ;;






let Red_Laws =
    "!(Op:*A->*A->*A) (e:*A).
      (!x. Op e x = x) /\ (!x. Op x e = x) 
      ==>
      % (1) Red_Unit -----------------------------------------%
      (Red Op Unit = e)  /\

      % (2) Red_Haplo ----------------------------------------%
      (Red Op (Haplo x) = x)  /\

      % (3) Red_Cat ------------------------------------------%
        (!s t. Red Op (Cat s t) = Op (Red Op s) (Red Op t))  /\

      % (4) Red_Prom -----------------------------------------%
        ((Red Op) o ((Red Cat):(*A Zrok)) = (Red Op) o (Map Red Op))  /\

      % (5) Map_Prom -----------------------------------------%
        (!f. (Map f) o (Red Cat) = (Red Cat) o (Map Map f))"
     ;;



